#define fc 2000;
#define fs 50;
#define ma 1;
 
 
 main()
{
// Step 1. Initialize System Control:
// PLL, WatchDog, enable Peripheral Clocks
// This example function is found in the DSP281x_SysCtrl.c file.
InitSysCtrl();


// Step 2. Initalize GPIO: 
// This example function is found in the DSP281x_Gpio.c file and
// illustrates how to set the GPIO to it's default state.
// InitGpio();  // Skipped for this example  
EALLOW;
   // Enable PWM pins
   GpioMuxRegs.GPAMUX.all = 0x00FF; // EVA PWM 1-6  pins
   GpioMuxRegs.GPBMUX.all = 0x00FF; // EVB PWM 7-12 pins
   EDIS;

// Step 3. Clear all interrupts and initialize PIE vector table:
// Disable CPU interrupts 
   DINT;

// Initialize PIE control registers to their default state.
// The default state is all PIE interrupts disabled and flags
// are cleared.  
// This function is found in the DSP281x_PieCtrl.c file.
   InitPieCtrl();

// Disable CPU interrupts and clear all CPU interrupt flags:
IER = 0x0000;
IFR = 0x0000;

// Initialize the PIE vector table with pointers to the shell Interrupt 
// Service Routines (ISR).  
// This will populate the entire table, even if the interrupt
// is not used in this example.  This is useful for debug purposes.
// The shell ISR routines are found in DSP281x_DefaultIsr.c.
// This function is found in DSP281x_PieVect.c.
   InitPieVectTable();

// Step 4. Initialize all the Device Peripherals:
// This function is found in DSP281x_InitPeripherals.c
// InitPeripherals(); // Not required for this example
   init_pwm_isr();
   
// Interrupts that are used in this example are re-mapped to
// ISR functions found within this file.  
   EALLOW;  // This is needed to write to EALLOW protected registers
   PieVectTable.T1UFINT = &init_pwm_isr;
   EDIS;    // This is needed to disable write to EALLOW protected registers   
  

// Enable PIE group 2 interrupt 4 for T1PINT and interrupt 6 for T1UFINT
    PieCtrlRegs.PIEIER2.all = 0x0028;

// Enable PIE group 4 interrupt 4 for T3PINT and interrupt 6 for T3UFINT
    PieCtrlRegs.PIEIER4.all = 0x0028;

// Enable CPU INT2 for T1PINT and T1UFINT , INT4 for T3PINT and T3UFINT 
   IER |= (M_INT2 | M_INT4);

    EINT;   // Enable Global interrupt INTM
    ERTM;   // Enable Global realtime interrupt DBGM
 
for(;;);

}


void init_PWM_isr()
{
int i;
float j,k,l;

int a[]=                            //A-phase sine wave
{
0,
9,
17,
26,
34,
43,
51,
60,
69,
77,
86,
94,
103,
111,
120,
128,
137,
146,
154,
163,
171,
180,
188,
197,
205,
213,
222,
230,
239,
247,
256,
264,
273,
281,
289,
298,
306,
314,
323,
331,
339,
348,
356,
364,
373,
381,
389,
397,
405,
414,
422,
430,
438,
446,
454,
462,
470,
478,
486,
495,
502,
511,
518,
526,
534,
542,
550,
558,
566,
573,
581,
589,
597,
604,
612,
620,
627,
635,
643,
650,
658,
665,
673,
680,
687,
695,
702,
710,
717,
724,
731,
739,
746,
753,
760,
767,
774,
781,
788,
795,
802,
809,
816,
823,
830,
837,
843,
850,
857,
863,
870,
877,
883,
890,
896,
903,
909,
916,
922,
928,
934,
941,
947,
953,
959,
965,
971,
977,
983,
989,
995,
1001,
1007,
1012,
1018,
1024,
1030,
1035,
1041,
1046,
1052,
1057,
1063,
1068,
1073,
1079,
1084,
1089,
1094,
1099,
1104,
1109,
1114,
1119,
1124,
1129,
1134,
1139,
1143,
1148,
1152,
1157,
1162,
1166,
1170,
1175,
1179,
1184,
1188,
1192,
1196,
1200,
1204,
1208,
1212,
1216,
1220,
1224,
1228,
1231,
1235,
1239,
1242,
1246,
1249,
1253,
1256,
1259,
1263,
1266,
1269,
1272,
1275,
1278,
1281,
1284,
1287,
1290,
1293,
1296,
1298,
1301,
1303,
1306,
1308,
1311,
1313,
1315,
1318,
1320,
1322,
1324,
1326,
1328,
1330,
1332,
1334,
1336,
1338,
1339,
1341,
1342,
1344,
1345,
1347,
1348,
1350,
1351,
1352,
1353,
1354,
1355,
1356,
1357,
1358,
1359,
1360,
1360,
1361,
1362,
1362,
1363,
1363,
1364,
1364,
1364,
1365,
1365,
1365,
1365,
1365,
1365,
1365,
1365,
1365,
1364,
1364,
1364,
1363,
1363,
1362,
1362,
1361,
1360,
1360,
1359,
1358,
1357,
1356,
1355,
1354,
1353,
1352,
1351,
1350,
1348,
1347,
1345,
1344,
1342,
1341,
1339,
1338,
1336,
1334,
1332,
1330,
1328,
1326,
1324,
1322,
1320,
1318,
1315,
1313,
1311,
1308,
1306,
1303,
1301,
1298,
1296,
1293,
1290,
1287,
1284,
1281,
1278,
1275,
1272,
1269,
1266,
1263,
1259,
1256,
1253,
1249,
1246,
1242,
1239,
1235,
1231,
1228,
1224,
1220,
1216,
1212,
1208,
1204,
1200,
1196,
1192,
1188,
1184,
1179,
1175,
1170,
1166,
1162,
1157,
1152,
1148,
1143,
1139,
1134,
1129,
1124,
1119,
1114,
1109,
1104,
1099,
1094,
1089,
1084,
1079,
1073,
1068,
1063,
1057,
1052,
1046,
1041,
1035,
1030,
1024,
1018,
1012,
1007,
1001,
995,
989,
983,
977,
971,
965,
959,
953,
947,
941,
934,
928,
922,
916,
909,
903,
896,
890,
883,
877,
870,
863,
857,
850,
843,
837,
830,
823,
816,
809,
802,
795,
788,
781,
774,
767,
760,
753,
746,
739,
731,
724,
717,
710,
702,
695,
687,
680,
673,
665,
658,
650,
643,
635,
627,
620,
612,
604,
597,
589,
581,
573,
566,
558,
550,
542,
534,
526,
518,
511,
502,
495,
486,
478,
470,
462,
454,
446,
438,
430,
422,
414,
405,
397,
389,
381,
373,
364,
356,
348,
339,
331,
323,
314,
306,
298,
289,
281,
273,
264,
256,
247,
239,
230,
222,
213,
205,
197,
188,
180,
171,
163,
154,
146,
137,
128,
120,
111,
103,
94,
86,
77,
69,
60,
51,
43,
34,
26,
17,
9,
0,
-9,
-17,
-26,
-34,
-43,
-51,
-60,
-69,
-77,
-86,
-94,
-103,
-111,
-120,
-128,
-137,
-146,
-154,
-163,
-171,
-180,
-188,
-197,
-205,
-213,
-222,
-230,
-239,
-247,
-256,
-264,
-273,
-281,
-289,
-298,
-306,
-314,
-323,
-331,
-339,
-348,
-356,
-364,
-373,
-381,
-389,
-397,
-405,
-414,
-422,
-430,
-438,
-446,
-454,
-462,
-470,
-478,
-486,
-495,
-502,
-511,
-518,
-526,
-534,
-542,
-550,
-558,
-566,
-573,
-581,
-589,
-597,
-604,
-612,
-620,
-627,
-635,
-643,
-650,
-658,
-665,
-673,
-680,
-687,
-695,
-702,
-710,
-717,
-724,
-731,
-739,
-746,
-753,
-760,
-767,
-774,
-781,
-788,
-795,
-802,
-809,
-816,
-823,
-830,
-837,
-843,
-850,
-857,
-863,
-870,
-877,
-883,
-890,
-896,
-903,
-909,
-916,
-922,
-928,
-934,
-941,
-947,
-953,
-959,
-965,
-971,
-977,
-983,
-989,
-995,
-1001,
-1007,
-1012,
-1018,
-1024,
-1030,
-1035,
-1041,
-1046,
-1052,
-1057,
-1063,
-1068,
-1073,
-1079,
-1084,
-1089,
-1094,
-1099,
-1104,
-1109,
-1114,
-1119,
-1124,
-1129,
-1134,
-1139,
-1143,
-1148,
-1152,
-1157,
-1162,
-1166,
-1170,
-1175,
-1179,
-1184,
-1188,
-1192,
-1196,
-1200,
-1204,
-1208,
-1212,
-1216,
-1220,
-1224,
-1228,
-1231,
-1235,
-1239,
-1242,
-1246,
-1249,
-1253,
-1256,
-1259,
-1263,
-1266,
-1269,
-1272,
-1275,
-1278,
-1281,
-1284,
-1287,
-1290,
-1293,
-1296,
-1298,
-1301,
-1303,
-1306,
-1308,
-1311,
-1313,
-1315,
-1318,
-1320,
-1322,
-1324,
-1326,
-1328,
-1330,
-1332,
-1334,
-1336,
-1338,
-1339,
-1341,
-1342,
-1344,
-1345,
-1347,
-1348,
-1350,
-1351,
-1352,
-1353,
-1354,
-1355,
-1356,
-1357,
-1358,
-1359,
-1360,
-1360,
-1361,
-1362,
-1362,
-1363,
-1363,
-1364,
-1364,
-1364,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1364,
-1364,
-1364,
-1363,
-1363,
-1362,
-1362,
-1361,
-1360,
-1360,
-1359,
-1358,
-1357,
-1356,
-1355,
-1354,
-1353,
-1352,
-1351,
-1350,
-1348,
-1347,
-1345,
-1344,
-1342,
-1341,
-1339,
-1338,
-1336,
-1334,
-1332,
-1330,
-1328,
-1326,
-1324,
-1322,
-1320,
-1318,
-1315,
-1313,
-1311,
-1308,
-1306,
-1303,
-1301,
-1298,
-1296,
-1293,
-1290,
-1287,
-1284,
-1281,
-1278,
-1275,
-1272,
-1269,
-1266,
-1263,
-1259,
-1256,
-1253,
-1249,
-1246,
-1242,
-1239,
-1235,
-1231,
-1228,
-1224,
-1220,
-1216,
-1212,
-1208,
-1204,
-1200,
-1196,
-1192,
-1188,
-1184,
-1179,
-1175,
-1170,
-1166,
-1162,
-1157,
-1152,
-1148,
-1143,
-1139,
-1134,
-1129,
-1124,
-1119,
-1114,
-1109,
-1104,
-1099,
-1094,
-1089,
-1084,
-1079,
-1073,
-1068,
-1063,
-1057,
-1052,
-1046,
-1041,
-1035,
-1030,
-1024,
-1018,
-1012,
-1007,
-1001,
-995,
-989,
-983,
-977,
-971,
-965,
-959,
-953,
-947,
-941,
-934,
-928,
-922,
-916,
-909,
-903,
-896,
-890,
-883,
-877,
-870,
-863,
-857,
-850,
-843,
-837,
-830,
-823,
-816,
-809,
-802,
-795,
-788,
-781,
-774,
-767,
-760,
-753,
-746,
-739,
-731,
-724,
-717,
-710,
-702,
-695,
-687,
-680,
-673,
-665,
-658,
-650,
-643,
-635,
-627,
-620,
-612,
-604,
-597,
-589,
-581,
-573,
-566,
-558,
-550,
-542,
-534,
-526,
-518,
-511,
-502,
-495,
-486,
-478,
-470,
-462,
-454,
-446,
-438,
-430,
-422,
-414,
-405,
-397,
-389,
-381,
-373,
-364,
-356,
-348,
-339,
-331,
-323,
-314,
-306,
-298,
-289,
-281,
-273,
-264,
-256,
-247,
-239,
-230,
-222,
-213,
-205,
-197,
-188,
-180,
-171,
-163,
-154,
-146,
-137,
-128,
-120,
-111,
-103,
-94,
-86,
-77,
-69,
-60,
-51,
-43,
-34,
-26,
-17,
-9
}

int b[]=                           //B-phase sine wave
{
1182,
1178,
1173,
1169,
1165,
1160,
1156,
1151,
1146,
1142,
1137,
1132,
1127,
1122,
1118,
1113,
1108,
1103,
1098,
1092,
1087,
1082,
1077,
1072,
1066,
1061,
1055,
1050,
1044,
1039,
1033,
1028,
1022,
1016,
1011,
1005,
999,
993,
987,
981,
975,
969,
963,
957,
951,
945,
939,
932,
926,
920,
913,
907,
900,
894,
888,
881,
874,
868,
861,
855,
848,
841,
834,
828,
821,
814,
807,
800,
793,
786,
779,
772,
765,
758,
751,
743,
736,
729,
722,
714,
707,
700,
692,
685,
678,
670,
663,
655,
648,
640,
632,
625,
617,
609,
602,
594,
586,
579,
571,
563,
555,
547,
539,
532,
524,
516,
508,
500,
492,
484,
476,
468,
460,
452,
443,
435,
427,
419,
411,
403,
394,
386,
378,
370,
362,
353,
345,
337,
328,
320,
312,
303,
295,
287,
278,
270,
261,
253,
244,
236,
228,
219,
211,
202,
194,
185,
177,
168,
160,
151,
143,
134,
126,
117,
109,
100,
91,
83,
74,
66,
57,
49,
40,
31,
23,
14,
6,
-3,
-11,
-20,
-29,
-37,
-46,
-54,
-63,
-71,
-80,
-89,
-97,
-106,
-114,
-123,
-131,
-140,
-148,
-157,
-165,
-174,
-182,
-191,
-199,
-208,
-216,
-225,
-233,
-242,
-250,
-259,
-267,
-275,
-284,
-292,
-301,
-309,
-317,
-326,
-334,
-342,
-351,
-359,
-367,
-375,
-384,
-392,
-400,
-408,
-416,
-425,
-433,
-441,
-449,
-457,
-465,
-473,
-481,
-489,
-497,
-505,
-513,
-521,
-529,
-537,
-545,
-553,
-560,
-568,
-576,
-584,
-591,
-599,
-607,
-615,
-622,
-630,
-637,
-645,
-653,
-660,
-668,
-675,
-683,
-690,
-697,
-705,
-712,
-719,
-727,
-734,
-741,
-748,
-755,
-762,
-770,
-777,
-784,
-791,
-798,
-805,
-811,
-818,
-825,
-832,
-839,
-846,
-852,
-859,
-866,
-872,
-879,
-885,
-892,
-898,
-905,
-911,
-918,
-924,
-930,
-937,
-943,
-949,
-955,
-961,
-967,
-973,
-979,
-985,
-991,
-997,
-1003,
-1009,
-1014,
-1020,
-1026,
-1031,
-1037,
-1043,
-1048,
-1054,
-1059,
-1064,
-1070,
-1075,
-1080,
-1086,
-1091,
-1096,
-1101,
-1106,
-1111,
-1116,
-1121,
-1126,
-1131,
-1135,
-1140,
-1145,
-1149,
-1154,
-1159,
-1163,
-1168,
-1172,
-1176,
-1181,
-1185,
-1189,
-1193,
-1198,
-1202,
-1206,
-1210,
-1214,
-1218,
-1221,
-1225,
-1229,
-1233,
-1236,
-1240,
-1244,
-1247,
-1250,
-1254,
-1257,
-1261,
-1264,
-1267,
-1270,
-1273,
-1276,
-1279,
-1282,
-1285,
-1288,
-1291,
-1294,
-1296,
-1299,
-1302,
-1304,
-1307,
-1309,
-1312,
-1314,
-1316,
-1318,
-1321,
-1323,
-1325,
-1327,
-1329,
-1331,
-1333,
-1335,
-1336,
-1338,
-1340,
-1341,
-1343,
-1344,
-1346,
-1347,
-1349,
-1350,
-1351,
-1352,
-1354,
-1355,
-1356,
-1357,
-1357,
-1358,
-1359,
-1360,
-1361,
-1361,
-1362,
-1363,
-1363,
-1363,
-1364,
-1364,
-1364,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1364,
-1364,
-1364,
-1363,
-1363,
-1363,
-1362,
-1362,
-1361,
-1360,
-1359,
-1359,
-1358,
-1357,
-1356,
-1355,
-1354,
-1353,
-1352,
-1350,
-1349,
-1348,
-1346,
-1345,
-1343,
-1342,
-1340,
-1339,
-1337,
-1335,
-1333,
-1332,
-1330,
-1328,
-1326,
-1324,
-1321,
-1319,
-1317,
-1315,
-1312,
-1310,
-1308,
-1305,
-1302,
-1300,
-1297,
-1295,
-1292,
-1289,
-1286,
-1283,
-1280,
-1277,
-1274,
-1271,
-1268,
-1265,
-1262,
-1258,
-1255,
-1252,
-1248,
-1245,
-1241,
-1238,
-1234,
-1230,
-1226,
-1223,
-1219,
-1215,
-1211,
-1207,
-1203,
-1199,
-1195,
-1191,
-1186,
-1182,
-1178,
-1173,
-1169,
-1165,
-1160,
-1156,
-1151,
-1146,
-1142,
-1137,
-1132,
-1127,
-1122,
-1118,
-1113,
-1108,
-1103,
-1098,
-1092,
-1087,
-1082,
-1077,
-1072,
-1066,
-1061,
-1055,
-1050,
-1044,
-1039,
-1033,
-1028,
-1022,
-1016,
-1011,
-1005,
-999,
-993,
-987,
-981,
-975,
-969,
-963,
-957,
-951,
-945,
-939,
-932,
-926,
-920,
-913,
-907,
-900,
-894,
-888,
-881,
-874,
-868,
-861,
-855,
-848,
-841,
-834,
-828,
-821,
-814,
-807,
-800,
-793,
-786,
-779,
-772,
-765,
-758,
-751,
-743,
-736,
-729,
-722,
-714,
-707,
-700,
-692,
-685,
-678,
-670,
-663,
-655,
-648,
-640,
-632,
-625,
-617,
-609,
-602,
-594,
-586,
-579,
-571,
-563,
-555,
-547,
-539,
-532,
-524,
-516,
-508,
-500,
-492,
-484,
-476,
-468,
-460,
-452,
-443,
-435,
-427,
-419,
-411,
-403,
-394,
-386,
-378,
-370,
-362,
-353,
-345,
-337,
-328,
-320,
-312,
-303,
-295,
-287,
-278,
-270,
-261,
-253,
-244,
-236,
-228,
-219,
-211,
-202,
-194,
-185,
-177,
-168,
-160,
-151,
-143,
-134,
-126,
-117,
-109,
-100,
-91,
-83,
-74,
-66,
-57,
-49,
-40,
-31,
-23,
-14,
-6,
3,
11,
20,
29,
37,
46,
54,
63,
71,
80,
89,
97,
106,
114,
123,
131,
140,
148,
157,
165,
174,
182,
191,
199,
208,
216,
225,
233,
242,
250,
259,
267,
275,
284,
292,
301,
309,
317,
326,
334,
342,
351,
359,
367,
375,
384,
392,
400,
408,
416,
425,
433,
441,
449,
457,
465,
473,
481,
489,
497,
505,
513,
521,
529,
537,
545,
553,
560,
568,
576,
584,
591,
599,
607,
615,
622,
630,
637,
645,
653,
660,
668,
675,
683,
690,
697,
705,
712,
719,
727,
734,
741,
748,
755,
762,
770,
777,
784,
791,
798,
805,
811,
818,
825,
832,
839,
846,
852,
859,
866,
872,
879,
885,
892,
898,
905,
911,
918,
924,
930,
937,
943,
949,
955,
961,
967,
973,
979,
985,
991,
997,
1003,
1009,
1014,
1020,
1026,
1031,
1037,
1043,
1048,
1054,
1059,
1064,
1070,
1075,
1080,
1086,
1091,
1096,
1101,
1106,
1111,
1116,
1121,
1126,
1131,
1135,
1140,
1145,
1149,
1154,
1159,
1163,
1168,
1172,
1176,
1181,
1185,
1189,
1193,
1198,
1202,
1206,
1210,
1214,
1218,
1221,
1225,
1229,
1233,
1236,
1240,
1244,
1247,
1250,
1254,
1257,
1261,
1264,
1267,
1270,
1273,
1276,
1279,
1282,
1285,
1288,
1291,
1294,
1296,
1299,
1302,
1304,
1307,
1309,
1312,
1314,
1316,
1318,
1321,
1323,
1325,
1327,
1329,
1331,
1333,
1335,
1336,
1338,
1340,
1341,
1343,
1344,
1346,
1347,
1349,
1350,
1351,
1352,
1354,
1355,
1356,
1357,
1357,
1358,
1359,
1360,
1361,
1361,
1362,
1363,
1363,
1363,
1364,
1364,
1364,
1365,
1365,
1365,
1365,
1365,
1365,
1365,
1365,
1364,
1364,
1364,
1363,
1363,
1363,
1362,
1362,
1361,
1360,
1359,
1359,
1358,
1357,
1356,
1355,
1354,
1353,
1352,
1350,
1349,
1348,
1346,
1345,
1343,
1342,
1340,
1339,
1337,
1335,
1333,
1332,
1330,
1328,
1326,
1324,
1321,
1319,
1317,
1315,
1312,
1310,
1308,
1305,
1302,
1300,
1297,
1295,
1292,
1289,
1286,
1283,
1280,
1277,
1274,
1271,
1268,
1265,
1262,
1258,
1255,
1252,
1248,
1245,
1241,
1238,
1234,
1230,
1226,
1223,
1219,
1215,
1211,
1207,
1203,
1199,
1195,
1191,
1186
}

int c[]=                       // C-phase sine wave
{
-1182,
-1186,
-1191,
-1195,
-1199,
-1203,
-1207,
-1211,
-1215,
-1219,
-1223,
-1226,
-1230,
-1234,
-1238,
-1241,
-1245,
-1248,
-1252,
-1255,
-1258,
-1262,
-1265,
-1268,
-1271,
-1274,
-1277,
-1280,
-1283,
-1286,
-1289,
-1292,
-1295,
-1297,
-1300,
-1302,
-1305,
-1308,
-1310,
-1312,
-1315,
-1317,
-1319,
-1321,
-1324,
-1326,
-1328,
-1330,
-1332,
-1333,
-1335,
-1337,
-1339,
-1340,
-1342,
-1343,
-1345,
-1346,
-1348,
-1349,
-1350,
-1352,
-1353,
-1354,
-1355,
-1356,
-1357,
-1358,
-1359,
-1359,
-1360,
-1361,
-1362,
-1362,
-1363,
-1363,
-1363,
-1364,
-1364,
-1364,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1365,
-1364,
-1364,
-1364,
-1363,
-1363,
-1363,
-1362,
-1361,
-1361,
-1360,
-1359,
-1358,
-1357,
-1357,
-1356,
-1355,
-1354,
-1352,
-1351,
-1350,
-1349,
-1347,
-1346,
-1344,
-1343,
-1341,
-1340,
-1338,
-1336,
-1335,
-1333,
-1331,
-1329,
-1327,
-1325,
-1323,
-1321,
-1318,
-1316,
-1314,
-1312,
-1309,
-1307,
-1304,
-1302,
-1299,
-1296,
-1294,
-1291,
-1288,
-1285,
-1282,
-1279,
-1276,
-1273,
-1270,
-1267,
-1264,
-1261,
-1257,
-1254,
-1250,
-1247,
-1244,
-1240,
-1236,
-1233,
-1229,
-1225,
-1221,
-1218,
-1214,
-1210,
-1206,
-1202,
-1198,
-1193,
-1189,
-1185,
-1181,
-1176,
-1172,
-1168,
-1163,
-1159,
-1154,
-1149,
-1145,
-1140,
-1135,
-1131,
-1126,
-1121,
-1116,
-1111,
-1106,
-1101,
-1096,
-1091,
-1086,
-1080,
-1075,
-1070,
-1064,
-1059,
-1054,
-1048,
-1043,
-1037,
-1031,
-1026,
-1020,
-1014,
-1009,
-1003,
-997,
-991,
-985,
-979,
-973,
-967,
-961,
-955,
-949,
-943,
-937,
-930,
-924,
-918,
-911,
-905,
-898,
-892,
-885,
-879,
-872,
-866,
-859,
-852,
-846,
-839,
-832,
-825,
-818,
-811,
-805,
-798,
-791,
-784,
-777,
-770,
-762,
-755,
-748,
-741,
-734,
-727,
-719,
-712,
-705,
-697,
-690,
-683,
-675,
-668,
-660,
-653,
-645,
-637,
-630,
-622,
-615,
-607,
-599,
-591,
-584,
-576,
-568,
-560,
-553,
-545,
-537,
-529,
-521,
-513,
-505,
-497,
-489,
-481,
-473,
-465,
-457,
-449,
-441,
-433,
-425,
-416,
-408,
-400,
-392,
-384,
-375,
-367,
-359,
-351,
-342,
-334,
-326,
-317,
-309,
-301,
-292,
-284,
-275,
-267,
-259,
-250,
-242,
-233,
-225,
-216,
-208,
-199,
-191,
-182,
-174,
-165,
-157,
-148,
-140,
-131,
-123,
-114,
-106,
-97,
-89,
-80,
-71,
-63,
-54,
-46,
-37,
-29,
-20,
-11,
-3,
6,
14,
23,
31,
40,
49,
57,
66,
74,
83,
91,
100,
109,
117,
126,
134,
143,
151,
160,
168,
177,
185,
194,
202,
211,
219,
228,
236,
244,
253,
261,
270,
278,
287,
295,
303,
312,
320,
328,
337,
345,
353,
362,
370,
378,
386,
394,
403,
411,
419,
427,
435,
443,
452,
460,
468,
476,
484,
492,
500,
508,
516,
524,
532,
539,
547,
555,
563,
571,
579,
586,
594,
602,
609,
617,
625,
632,
640,
648,
655,
663,
670,
678,
685,
692,
700,
707,
714,
722,
729,
736,
743,
751,
758,
765,
772,
779,
786,
793,
800,
807,
814,
821,
828,
834,
841,
848,
855,
861,
868,
874,
881,
888,
894,
900,
907,
913,
920,
926,
932,
939,
945,
951,
957,
963,
969,
975,
981,
987,
993,
999,
1005,
1011,
1016,
1022,
1028,
1033,
1039,
1044,
1050,
1055,
1061,
1066,
1072,
1077,
1082,
1087,
1092,
1098,
1103,
1108,
1113,
1118,
1122,
1127,
1132,
1137,
1142,
1146,
1151,
1156,
1160,
1165,
1169,
1173,
1178,
1182,
1186,
1191,
1195,
1199,
1203,
1207,
1211,
1215,
1219,
1223,
1226,
1230,
1234,
1238,
1241,
1245,
1248,
1252,
1255,
1258,
1262,
1265,
1268,
1271,
1274,
1277,
1280,
1283,
1286,
1289,
1292,
1295,
1297,
1300,
1302,
1305,
1308,
1310,
1312,
1315,
1317,
1319,
1321,
1324,
1326,
1328,
1330,
1332,
1333,
1335,
1337,
1339,
1340,
1342,
1343,
1345,
1346,
1348,
1349,
1350,
1352,
1353,
1354,
1355,
1356,
1357,
1358,
1359,
1359,
1360,
1361,
1362,
1362,
1363,
1363,
1363,
1364,
1364,
1364,
1365,
1365,
1365,
1365,
1365,
1365,
1365,
1365,
1364,
1364,
1364,
1363,
1363,
1363,
1362,
1361,
1361,
1360,
1359,
1358,
1357,
1357,
1356,
1355,
1354,
1352,
1351,
1350,
1349,
1347,
1346,
1344,
1343,
1341,
1340,
1338,
1336,
1335,
1333,
1331,
1329,
1327,
1325,
1323,
1321,
1318,
1316,
1314,
1312,
1309,
1307,
1304,
1302,
1299,
1296,
1294,
1291,
1288,
1285,
1282,
1279,
1276,
1273,
1270,
1267,
1264,
1261,
1257,
1254,
1250,
1247,
1244,
1240,
1236,
1233,
1229,
1225,
1221,
1218,
1214,
1210,
1206,
1202,
1198,
1193,
1189,
1185,
1181,
1176,
1172,
1168,
1163,
1159,
1154,
1149,
1145,
1140,
1135,
1131,
1126,
1121,
1116,
1111,
1106,
1101,
1096,
1091,
1086,
1080,
1075,
1070,
1064,
1059,
1054,
1048,
1043,
1037,
1031,
1026,
1020,
1014,
1009,
1003,
997,
991,
985,
979,
973,
967,
961,
955,
949,
943,
937,
930,
924,
918,
911,
905,
898,
892,
885,
879,
872,
866,
859,
852,
846,
839,
832,
825,
818,
811,
805,
798,
791,
784,
777,
770,
762,
755,
748,
741,
734,
727,
719,
712,
705,
697,
690,
683,
675,
668,
660,
653,
645,
637,
630,
622,
615,
607,
599,
591,
584,
576,
568,
560,
553,
545,
537,
529,
521,
513,
505,
497,
489,
481,
473,
465,
457,
449,
441,
433,
425,
416,
408,
400,
392,
384,
375,
367,
359,
351,
342,
334,
326,
317,
309,
301,
292,
284,
275,
267,
259,
250,
242,
233,
225,
216,
208,
199,
191,
182,
174,
165,
157,
148,
140,
131,
123,
114,
106,
97,
89,
80,
71,
63,
54,
46,
37,
29,
20,
11,
3,
-6,
-14,
-23,
-31,
-40,
-49,
-57,
-66,
-74,
-83,
-91,
-100,
-109,
-117,
-126,
-134,
-143,
-151,
-160,
-168,
-177,
-185,
-194,
-202,
-211,
-219,
-228,
-236,
-244,
-253,
-261,
-270,
-278,
-287,
-295,
-303,
-312,
-320,
-328,
-337,
-345,
-353,
-362,
-370,
-378,
-386,
-394,
-403,
-411,
-419,
-427,
-435,
-443,
-452,
-460,
-468,
-476,
-484,
-492,
-500,
-508,
-516,
-524,
-532,
-539,
-547,
-555,
-563,
-571,
-579,
-586,
-594,
-602,
-609,
-617,
-625,
-632,
-640,
-648,
-655,
-663,
-670,
-678,
-685,
-692,
-700,
-707,
-714,
-722,
-729,
-736,
-743,
-751,
-758,
-765,
-772,
-779,
-786,
-793,
-800,
-807,
-814,
-821,
-828,
-834,
-841,
-848,
-855,
-861,
-868,
-874,
-881,
-888,
-894,
-900,
-907,
-913,
-920,
-926,
-932,
-939,
-945,
-951,
-957,
-963,
-969,
-975,
-981,
-987,
-993,
-999,
-1005,
-1011,
-1016,
-1022,
-1028,
-1033,
-1039,
-1044,
-1050,
-1055,
-1061,
-1066,
-1072,
-1077,
-1082,
-1087,
-1092,
-1098,
-1103,
-1108,
-1113,
-1118,
-1122,
-1127,
-1132,
-1137,
-1142,
-1146,
-1151,
-1156,
-1160,
-1165
-1169,
-1173,
-1178
}

// Enable Period interrupt and Under flow interrupt bits for GP timer 1 and timer 3

EvaRegs.EVAIMRA.bit.T1UFINT=1;
EvaRegs.EVAIFRA.bit.T1UFINT=1;

EvaRegs.EVAIMRA.bit.T3UFINT=1;
EvaRegs.EVAIFRA.bit.T3UFINT=1;

// EVA Configure  PWM1-PWM6 

   // Initalize EVA Timer1 
EvaRegs.T1CNT = 0x0000;      // Timer1 counter
EvaRegs.T1PR = 0x124F;       // Timer1 period
 
   // TMODE = continuous up/down
   // Timer enable
   // X/8
EvaRegs.T1CON.all = 0x0BC1;   

    // Initalize EVA Timer2 
EvaRegs.T2CNT = 0x0000;      // Timer2 counter
   // TMODE = continuous up/down
   // Timer enable
   // X/8
EvaRegs.T2CON.all = 0x0BC1;

  // Initalize EVA Timer3 
EvaRegs.T3CNT = 0x0000;      // Timer3 counter  
EvaRegs.T3PR = 0x124F;       // Timer3 period
  
    
   // TMODE = continuous up/down
   // Timer enable
   // Timer compare enable
EvaRegs.T3CON.all = 0x0BC1;   

   // Initalize EVA Timer4 
EvaRegs.T4CNT = 0x0000;      // Timer2 counter
   // TMODE = continuous up/down
   // Timer enable
   // X/8
EvaRegs.T4CON.all = 0x0BC1;
  
  
  // Compare action control.  Action that takes place
  // on a cmpare event
  // output pin 1 CMPR1 - active high
  // output pin 2 CMPR1 - active low
  // output pin 3 CMPR2 - active high
  // output pin 4 CMPR2 - active low
  // output pin 5 CMPR3 - active high
  // output pin 6 CMPR3 - active low
  EvaRegs.ACTRA.all = 0x0666;
  EvaRegs.DBTCONA.all = 0x0000; // Disable deadband
  EvaRegs.COMCONA.all = 0x82E0;
  EvaRegs.EXTCONA.all = 0x0009;

   
  // Compare action control.  Action that takes place
  // on a cmpare event
  // output pin 7  CMPR4 - active high
  // output pin 8  CMPR4 - active low
  // output pin 9  CMPR5 - active high
  // output pin 10 CMPR5 - active low
  // output pin 11 CMPR6 - active high
  // output pin 12 CMPR6 - active low
  EvaRegs.ACTRB.all = 0x0666;
  EvaRegs.DBTCONB.all = 0x0000; // Disable deadband
  EvaRegs.COMCONB.all = 0x82E0;
  EvaRegs.EXTCONB.all = 0x0009;


j=j+40*ma;

i=j;

ka=a[i];



kb=b[i];



kc=c[i];


// Enable compare for PWM1-PWM6
  EvaRegs.CMPR1 = ka;
  EvaRegs.CMPR2 = kb;
  EvaRegs.CMPR3 = kc;

// Enable compare for PWM7-PWM12
  EvaRegs.CMPR4 = ka;
  EvaRegs.CMPR5 = kb;
  EvaRegs.CMPR6 = kc;

}

